﻿<AML>
 <Item type="Method" id="8858E4E165304F4FB9E6C9295D6E09CD" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_purchase_after_delete
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                if delete purchase invoice,delete acc_journal_details,acc_journal_header according by that purchase invoice.

            Hooks:
                Type:		ItemType : pop_purchase_invoice
                Event:		Server Events ( onBeforeDelete )
                
            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_purchase_after_delete";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();
                string header_id = "";

                Item acc_Ledger_Header_Select = myInnovator.applySQL("select * from  innovator.[acc_journal_header] where acc_reftransactionid='" + _id + "' ");
                var acc_Ledger_Header_Select_count = acc_Ledger_Header_Select.getItemCount();
                if (acc_Ledger_Header_Select_count > 0)
                {
                    acc_Ledger_Header_Select = acc_Ledger_Header_Select.getItemByIndex(0);
                    header_id = acc_Ledger_Header_Select.getProperty("id");
                }
                Item delete_GL_Detail = myInnovator.applySQL("Delete from  innovator.[acc_journal_details] WHERE source_id='" + header_id + "'");
                Item delete_GL_header = myInnovator.applySQL("Delete from  innovator.[acc_journal_header] WHERE id='" + header_id + "'");
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_purchase_after_delete</name>
 </Item>
</AML>